package fr.lip6.move.pnml.framework.utils;

/**
 * This contains data and tools for pretty printing PNML document at export.
 *
 * @author Guillaume Giffo
 *
 */
public class PrettyPrintData {

    /**
     * default tab value.
     */
    public static final String DEFAULTTAB = "  ";

    /**
     * the String used as tabulation for pretty printing.
     */
    private String lineHeader = DEFAULTTAB;

    /**
     *
     */
    private String currentLineHeader = "";

    /**
     * the level of tabulation for pretty printing.
     */
    private int level;

    /**
     * @return the ppSpacer
     */
    public final String getLineHeader() {
        return lineHeader;
    }

    /**
     * @param newLineHeader
     *            the LineHeader to set
     */
    public final void setLineHeader(String newLineHeader) {
        lineHeader = newLineHeader;
    }

    /**
     * @return the new current line header
     */
    public final String increaseLineHeaderLevel() {
        level++;
        currentLineHeader += lineHeader;
        return currentLineHeader;
    }

    /**
     * @return the new current line header
     */
    public final String decreaseLineHeaderLevel() {
        level--;
        currentLineHeader = "";
        for (int i = 0; i < level; i++) {
            currentLineHeader += lineHeader;
        }
        return currentLineHeader;
    }

    /**
     * @return the level
     */
    public final int getLevel() {
        return level;
    }

    /**
     * @return the currentLineHeader
     */
    public final String getCurrentLineHeader() {
        return currentLineHeader;
    }
}
