/**
 * (C) University Pierre & Marie Curie - UMR CNRS 7606 (LIP6/MoVe)
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *  
 *  Contributors: 
 *    Lom HILLAH (LIP6) - Initial models and implementation
 *    Rachid Alahyane (UPMC) - Infrastructure and continuous integration
 *    Bastien Bouzerau (UPMC) - Architecture
 *    Guillaume Giffo (UPMC)  - Code generation refactoring, high-level API
 *
 * $Id$
 */
package fr.lip6.move.pnml.symmetricnet.hlcorestructure;

import java.util.List;

import org.apache.axiom.om.OMElement;
import org.eclipse.emf.common.util.DiagnosticChain;

import fr.lip6.move.pnml.framework.utils.IdRefLinker;
import fr.lip6.move.pnml.framework.utils.exception.InnerBuildException;
import fr.lip6.move.pnml.framework.utils.exception.InvalidIDException;
import fr.lip6.move.pnml.framework.utils.exception.VoidRepositoryException;

/**
 * <!-- begin-user-doc --> A representation of the model object '
 * <em><b>Transition Node</b></em>'. <!-- end-user-doc -->
 * 
 * <p>
 * The following features are supported:
 * <ul>
 * <li>
 * {@link fr.lip6.move.pnml.symmetricnet.hlcorestructure.TransitionNode#getReferencingTransitions
 * <em>Referencing Transitions</em>}</li>
 * </ul>
 * </p>
 * 
 * @see fr.lip6.move.pnml.symmetricnet.hlcorestructure.HlcorestructurePackage#getTransitionNode()
 * @model abstract="true"
 * @generated
 */
public interface TransitionNode extends Node {
	/**
	 * Returns the value of the '<em><b>Referencing Transitions</b></em>'
	 * reference list. The list contents are of type
	 * {@link fr.lip6.move.pnml.symmetricnet.hlcorestructure.RefTransition}. It
	 * is bidirectional and its opposite is '
	 * {@link fr.lip6.move.pnml.symmetricnet.hlcorestructure.RefTransition#getRef
	 * <em>Ref</em>}'. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Referencing Transitions</em>' reference list
	 * isn't clear, there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Referencing Transitions</em>' reference
	 *         list.
	 * @see fr.lip6.move.pnml.symmetricnet.hlcorestructure.HlcorestructurePackage#getTransitionNode_ReferencingTransitions()
	 * @see fr.lip6.move.pnml.symmetricnet.hlcorestructure.RefTransition#getRef
	 * @model opposite="ref" changeable="false"
	 * @generated
	 */
	List<RefTransition> getReferencingTransitions();

	// public abstract void idRefHang(java.util.ArrayList<Object> oList);
	public abstract String toPNML();

	public abstract void fromPNML(OMElement locRoot, IdRefLinker idr)
			throws InnerBuildException, InvalidIDException,
			VoidRepositoryException;

	public abstract boolean validateOCL(DiagnosticChain diagnostics);
} // TransitionNode
