/**
 * (C) University Pierre & Marie Curie - UMR CNRS 7606 (LIP6/MoVe)
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *  
 *  Contributors: 
 *    Lom HILLAH (LIP6) - Initial models and implementation
 *    Rachid Alahyane (UPMC) - Infrastructure and continuous integration
 *    Bastien Bouzerau (UPMC) - Architecture
 *    Guillaume Giffo (UPMC)  - Code generation refactoring, high-level API
 *
 * $Id ggiffo, Wed Sep 10 13:41:15 CEST 2008$
 */
package fr.lip6.move.pnml.symmetricnet.hlcorestructure.hlapi;

import fr.lip6.move.pnml.symmetricnet.hlcorestructure.FontAlign;

public enum FontAlignHLAPI {
	LEFT("left"), CENTER("center"), RIGHT("right");

	private final FontAlign item;

	private FontAlignHLAPI(String name) {
		this.item = FontAlign.get(name);
	}

	/**
	 * Return one HLAPI enum (used for tests).
	 * 
	 * @return one of the enum, null if the int is "out of bounds"
	 */
	public static FontAlignHLAPI get(int num) {

		if (num == 0) {
			return LEFT;
		}

		if (num == 1) {
			return CENTER;
		}

		if (num == 2) {
			return RIGHT;
		}

		return null;
	}

	public FontAlign getContainedItem() {
		return item;
	}

}